/*
 * Index.java
 */
package de.holzem.refbuilder;

import java.util.Iterator;
import java.util.TreeMap;

/**
 * Index
 */
public class Index extends TreeMap
{
	
	public void add(String name, String shortName, String source, String title)
	{
		String l = name.toUpperCase().substring(0,1);
		Letter letter = (Letter)get(l);
		if (letter == null) {
			letter = new Letter(l);
			put(l, letter);
		}
		letter.add(name, shortName, source, title);
	}
	
	/**
	 * Convert content to XML
	 * 
	 * @return XML-representation
	 */
	public String toXml()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("<index>\n");
		for (Iterator i = values().iterator(); i.hasNext();) {
			Letter l = (Letter)i.next();
			sb.append(l.toXml());
		}
		sb.append("</index>\n");
		return sb.toString();
	}
}