/*
 * Letter.java
 */
package de.holzem.refbuilder;

import java.util.Iterator;
import java.util.TreeMap;

/**
 * Letter
 */
public class Letter extends TreeMap
{
	String letter;

	public Letter(String letter)
	{
		this.letter = letter;
	}

	public void add(String name, String shortName, String source, String title)
	{
		Entry entry = (Entry)get(name);
		if (entry == null) {
			entry = new Entry(name, shortName);
			put(name, entry);
		}
		entry.add(source, title);
	}

	/**
	 * Convert content to XML
	 * 
	 * @return XML-representation
	 */
	public String toXml()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("<letter name=\"").append(letter).append("\">\n");
		for (Iterator i = values().iterator(); i.hasNext();) {
			Object o = i.next();
			Entry entry = (Entry)o;
			sb.append(entry.toXml());
		}
		sb.append("</letter>\n");
		return sb.toString();
	}

	/**
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object arg0)
	{
		Letter other = (Letter)arg0;
		return letter.toUpperCase().compareTo(other.letter.toUpperCase());
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("Letter (").append(letter).append(")");
		return sb.toString();
	}
}