/*
 * ThumbRef.java
 */
package de.holzem.refbuilder;

import java.util.Locale;

/**
 * ThumbRef
 */
public class ThumbRef implements Comparable
{
	private static final Locale locale = new Locale("de");
	private String source;
	private String map;
	private String title;
	private String key;

	/**
	 * @param source
	 * @param map
	 * @param title
	 */
	public ThumbRef(String source, String map, String title)
	{
		super();
		this.source = source;
		this.map = map;
		this.title = title;
		if (title != null) {
			this.key = title.toUpperCase(locale).replace("", "AE")
					.replace("", "OE").replace("", "UE");
		} else {
			System.err.println("WARNING <Titlethumb> before <title> map =" + map
					+ ", source=" + source);
		}
	}

	/**
	 * @param title
	 *          The title to set.
	 */
	public void setTitle(String title)
	{
		this.title = title;
		this.key = title.toUpperCase(locale).replace("", "AE").replace("", "OE")
				.replace("", "UE");
	}

	/**
	 * @return xml-representation of ThumbRef
	 */
	public String toXml()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("<thumbref map=\"").append(map).append("\" source=\"").append(
				source).append("\" title=\"").append(title).append("\" />");
		return sb.toString();
	}

	/**
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object arg0)
	{
		ThumbRef other = (ThumbRef)arg0;
		int mapCompare = map.compareTo(other.map);
		if (mapCompare != 0) {
			return mapCompare;
		}
		return key.toUpperCase().compareTo(other.key.toUpperCase());
	}
}